
  -----------------------------
  -- INIT
  -----------------------------

  --get the addon namespace
  local addon, ns = ...
  local cfg = ns.cfg

  -----------------------------
  -- CHARSPECIFIC REWRITES
  -----------------------------

  local player_name, _ = UnitName("player")
  local _, player_class = UnitClass("player")

  -- this file allows you to override default class settings with special settings for your own character
  -- ATTENTION: if you character name contains UTF-8 characters like âôû and such. Make sure this files is saved in UTF-8 file format

  
  if player_class == "PALADIN" then
    --Paladin Buff List
    cfg.rf3_BuffList = {
      [1] = {
        spellid = 90174, -- dessein divin
        spec = nil,
        size = 30,
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = -20, y = -130 },
        unit = "player",
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          found = {
            frame = 1,
            icon = 1,
          },
          not_found = {
            frame = 0.4,
            icon = 0.6,
          },
        },
      },
      [2] = {
      	spellid = 19740,
        spelllist = { 19740, 116956, 93435, 128997, }, -- buff maitrise
        spec = nil,
        size = 22,
        pos = { a1 = "BOTTOM", a2 = "BOTTOM", af = "UIParent", x = -330, y = 110 },
        unit = "player",
        validate_unit   = true,
        ismine          = false,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = false,
        alpha = {
          found = {
            frame = 1,
            icon = 1,
          },
          not_found = {
            frame = 0.4,
            icon = 0.6,
          },
        },
      },
      [3] = {
      	spellid = 20217,
        spelllist = { 20217, 1126, 117666, 90363, }, -- buff stats
        spec = nil,
        size = 22,
        pos = { a1 = "BOTTOM", a2 = "BOTTOM", af = "UIParent", x = -300, y = 110 },
        unit = "player",
        validate_unit   = true,
        ismine          = false,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = false,
        alpha = {
          found = {
            frame = 1,
            icon = 1,
          },
          not_found = {
            frame = 0.4,
            icon = 0.6,
          },
        },
      },
      [4] = {
      	spellid = 21562,
        spelllist = { 21562, 6307, 469, 90364, }, -- buff endurance
        spec = nil,
        size = 22,
        pos = { a1 = "BOTTOM", a2 = "BOTTOM", af = "UIParent", x = -270, y = 110 },
        unit = "player",
        validate_unit   = true,
        ismine          = false,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = false,
        alpha = {
          found = {
            frame = 1,
            icon = 1,
          },
          not_found = {
            frame = 0.4,
            icon = 0.6,
          },
        },
      },
      [5] = {
      	spellid = 1459,
        spelllist = { 1459, 61316, 77747, 109773, 126309, }, -- buff power
        spec = nil,
        size = 22,
        pos = { a1 = "BOTTOM", a2 = "BOTTOM", af = "UIParent", x = -360, y = 110 },
        unit = "player",
        validate_unit   = true,
        ismine          = false,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = false,
        alpha = {
          found = {
            frame = 1,
            icon = 1,
          },
          not_found = {
            frame = 0.4,
            icon = 0.6,
          },
        },
      },
      [6] = {
        spellid = 53563, --guide de lumière
        spec = nil,
        size = 30,
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = 200, y = -170 },
        unit = "focus",
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          found = {
            frame = 1,
            icon = 1,
          },
          not_found = {
            frame = 0.4,
            icon = 0.6,
          },
        },
      },
    }

    --Rothars Debuff List
--    cfg.rf3_DebuffList = {
--      [1] = {
--        spellid = 115798, --weakened blows
--        spec = nil,
--        size = 22,
--       pos = { a1 = "BOTTOM", a2 = "BOTTOM", af = "UIParent", x = -140, y = 110 },
--        unit = "target",
--        validate_unit   = true,
--        ismine          = false,
--        desaturate      = true,
--        move_ingame     = true,
--        hide_ooc        = true,
--        alpha = {
--          found = {
--            frame = 1,
--            icon = 1,
--          },
--          not_found = {
--            frame = 0.4,
--            icon = 0.6,
--          },
--        },
--      },
--    }

  --Paladin Cooldown List
    cfg.rf3_CooldownList = {
      [1] = {
        spellid = 31884, --ailes
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = -200, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [2] = {
        spellid = 54428, --supplique
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = -160, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [3] = {
        spellid = 114158, --marteau
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = -120, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [4] = {
        spellid = 31842, --faveurdivine
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = -80, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [5] = {
        spellid = 31821, --auradevotion
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = -40, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [6] = {
        spellid = 86669, --gardienrois
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = 40, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [7] = {
        spellid = 20473, --horion
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = 20, y = -130 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [8] = {
        spellid = 633, --imposition des mains
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = 80, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [9] = {
        spellid = 4987, --epuration
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = 120, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [10] = {
        spellid = 498, --protection divine
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = 160, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
    }

  end

  if player_class == "SHAMAN" then
    --Shaman Buff List
    cfg.rf3_BuffList = {
      [1] = {
      	spellid = 19740,
        spelllist = { 19740, 116956, 93435, 128997, }, -- buff maitrise
        spec = nil,
        size = 22,
        pos = { a1 = "BOTTOM", a2 = "BOTTOM", af = "UIParent", x = -330, y = 110 },
        unit = "player",
        validate_unit   = true,
        ismine          = false,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = false,
        alpha = {
          found = {
            frame = 1,
            icon = 1,
          },
          not_found = {
            frame = 0.4,
            icon = 0.6,
          },
        },
      },
      [2] = {
      	spellid = 20217,
        spelllist = { 20217, 1126, 117666, 90363, }, -- buff stats
        spec = nil,
        size = 22,
        pos = { a1 = "BOTTOM", a2 = "BOTTOM", af = "UIParent", x = -300, y = 110 },
        unit = "player",
        validate_unit   = true,
        ismine          = false,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = false,
        alpha = {
          found = {
            frame = 1,
            icon = 1,
          },
          not_found = {
            frame = 0.4,
            icon = 0.6,
          },
        },
      },
      [3] = {
      	spellid = 21562,
        spelllist = { 21562, 6307, 469, 90364, }, -- buff endurance
        spec = nil,
        size = 22,
        pos = { a1 = "BOTTOM", a2 = "BOTTOM", af = "UIParent", x = -270, y = 110 },
        unit = "player",
        validate_unit   = true,
        ismine          = false,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = false,
        alpha = {
          found = {
            frame = 1,
            icon = 1,
          },
          not_found = {
            frame = 0.4,
            icon = 0.6,
          },
        },
      },
      [4] = {
      	spellid = 1459,
        spelllist = { 1459, 61316, 77747, 109773, 126309, }, -- buff power
        spec = nil,
        size = 22,
        pos = { a1 = "BOTTOM", a2 = "BOTTOM", af = "UIParent", x = -360, y = 110 },
        unit = "player",
        validate_unit   = true,
        ismine          = false,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = false,
        alpha = {
          found = {
            frame = 1,
            icon = 1,
          },
          not_found = {
            frame = 0.4,
            icon = 0.6,
          },
        },
      },
    	[5] = {
        spellid = 974, --bouclier de terre
        spec = nil,
        size = 30,
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = 200, y = -170 },
        unit = "focus",
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          found = {
            frame = 1,
            icon = 1,
          },
          not_found = {
            frame = 0.4,
            icon = 0.6,
          },
        },
      },
    }

    --Rothars Debuff List
--    cfg.rf3_DebuffList = {
--      [1] = {
--        spellid = 115798, --weakened blows
--        spec = nil,
--        size = 22,
--       pos = { a1 = "BOTTOM", a2 = "BOTTOM", af = "UIParent", x = -140, y = 110 },
--        unit = "target",
--        validate_unit   = true,
--        ismine          = false,
--        desaturate      = true,
--        move_ingame     = true,
--        hide_ooc        = true,
--        alpha = {
--          found = {
--            frame = 1,
--            icon = 1,
--          },
--          not_found = {
--            frame = 0.4,
--            icon = 0.6,
--          },
--        },
--      },
--    }

  --Shaman Cooldown List
    cfg.rf3_CooldownList = {
      [1] = {
        spellid = 5394, --totem guerisseur
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = -200, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [2] = {
        spellid = 16190, --totem de vague de mana
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = -160, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [3] = {
        spellid = 108280, --totem de maree de soins
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = -120, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [4] = {
        spellid = 98008, --totem de liens d esprit
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = -80, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [5] = {
        spellid = 79206, --grace de marcheur des esprits
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = -40, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [6] = {
        spellid = 16188, --rapidite ancestrale
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = 40, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [7] = {
        spellid = 61295, --remous
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = 20, y = -130 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [8] = {
        spellid = 114049, --ascendance
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = 80, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [9] = {
        spellid = 51886, --purifier l esprit
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = 120, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [10] = {
        spellid = 108271, --transfert astral
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = 160, y = -170 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
      [11] = {
        spellid = 73920, --pluie guerisseuse
        --spec = nil,
        size = 30,
        framestrata = "LOW",
        pos = { a1 = "CENTER", a2 = "CENTER", af = "UIParent", x = -20, y = -130 },
        validate_unit   = true,
        ismine          = true,
        desaturate      = true,
        move_ingame     = true,
        hide_ooc        = true,
        alpha = {
          cooldown = {
            frame = 0.4,
            icon = 0.6,
          },
          no_cooldown = {
            frame = 1,
            icon = 1,
          },
        },
      },
    }

  end
